<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2012 Thomas Deuling <typo3@coding.ms>, coding.ms
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

/**
 * Selection for Grid-Elements Classes
 *
 * @package	TYPO3
 * @subpackage	ftm
 */
class Tx_Ftm_Backend_GridElementClassesRow {

	/**
	 * Render a Selection for Grid-Elements Classes
	 *
	 * @param array $parameters
	 * @param mixed $parentObject
	 * @return string
	 */
	public function renderField(array &$parameters, &$parentObject) {
		    
        // Vars
        $uid   = &$parameters["row"]["uid"];
		$name  = $parameters['itemFormElName'];
		$value = $parameters['itemFormElValue'];
        
        // Initial Wert
        if(trim($value)=="") {
            $value = 'none none none none';
        }
        $values = explode(' ', $value);


        // echo "<pre>";
        // var_dump(&$parameters["row"]["uid"]);
        // echo "</pre>";
        // die(serialize(&$parentObject['_THIS_UID']));

        
        // Hidden-Field zum Speichern
        $hidden = '<input type="hidden" name="'.htmlspecialchars($name).'" value="'.htmlspecialchars($value).'" id="ftm_gridElementClasses_'.$uid.'"/>';
        
		
        $fileadminFolder = t3lib_div::getFileAbsFileName("fileadmin/");
        
        if($handle=opendir($fileadminFolder)) {
            while($file=readdir($handle)){
                if(substr($file , 0, 1) != ".") {
                    
                    // Aber nur wenn es darin das ImageHoverEffect-Verzeichnis gibt
                    $gridElementLayoutsPath = $fileadminFolder.$file.'/template/less/0_basicLess/6_grid_element_layouts/';
                    if(@file_exists($gridElementLayoutsPath)) {
                    
                        for($i=0 ; $i<=3 ; $i++) {
                           
                            //  onchange="if (confirm(TBE_EDITOR.labels.onChangeAlert) && TBE_EDITOR.checkSubmit(-1)){ TBE_EDITOR.submitForm() };"
                            $select.= '<select name="'.htmlspecialchars($name).'['.$i.']"  class="formField select" onchange="ftm_updateGridElementClasses_'.$uid.'(this.value, '.$i.')">' . LF;
                            $select.= '<option value="none">-</option>' . LF;
                        
                            if($handleLess=opendir($gridElementLayoutsPath)) {
                                while($fileLess=readdir($handleLess)){
                                    if(substr($fileLess , 0, 1) != ".") {
                        
                                        $selected = (str_replace(".less", "", $fileLess) === $values[$i] ? ' selected="selected"' : '');
                                        $select.= '<option value="'.str_replace(".less", "", $fileLess).'" '.$selected.'>'.str_replace(".less", "", $fileLess).' ('.$file.')</option>' . LF;
                                    }
                                }
                            }
                            $select.= '</select>&nbsp;&nbsp;'; 
                        }
                        
                    }
                   
                        
                }
            }
        }
        
        $script = '<script type="text/javascript">'.LF;
        $script.= 'function ftm_updateGridElementClasses_'.$uid.'(value, no) {'.LF;
        $script.= '  var tempValue  = document.getElementById("ftm_gridElementClasses_'.$uid.'").value;'.LF;
        $script.= '  var valueParts = tempValue.split(\' \');'.LF;
        $script.= '  valueParts[no] = value;'.LF;
        $script.= '  document.getElementById("ftm_gridElementClasses_'.$uid.'").value = valueParts.join(\' \');'.LF;
        $script.= '}'.LF;
        $script.= '</script>'.LF;
        
        
        return '<div>'.$select.$hidden.$script.'</div>' . LF;
	}


}

?>