<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2012 Thomas Deuling <typo3@coding.ms>, coding.ms
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

/**
 * Class that renders a selection field for Fluid FCE template selection
 * Abgeschaut bei FCESelector der fed-Extension
 *
 * @package    TYPO3
 * @subpackage    ftm
 */
class Tx_Ftm_Backend_InformationRow {

    /**
     * Render a Flexible Content Element type selection field
     *
     * @param array $parameters
     * @param mixed $parentObject
     * @return string
     */
    public function renderField(array &$parameters, &$parentObject) {
            
            
        // Vars
        $uid   = $parameters["row"]["uid"];
        $pid   = $parameters["row"]["pid"];
        $name  = $parameters['itemFormElName'];
        $value = $parameters['itemFormElValue'];
        $imagePath = "/typo3conf/ext/ftm/Resources/Public/Icons/";
        
        // foreach ($parameters as $key => $value) {
            // $select .= $key."<br>";
        // }
        
        // echo "<pre>";
        // var_dump(&$parameters["row"]);
        // echo "</pre>";
        // die(serialize(&$parentObject['_THIS_UID']));
        
        
        // Allgemeine Extension-Informationen
        if($parameters['field']=="extensions_info") {
            $infotext = "Hier finden Sie alle unterstützten Extensions.. hier noch mehr Text, weitere Extensions können Sie";
            $infotext.= "natürlich auch wie gewohnt von Hand hinzufügen.<br />";
            $infotext.= "<br />";
            $infotext.= "Die Reihenfolge der Extensions und deren TypoScript im generierten Setup kann via Drag'n'Drop verändert werden.<br />";
            $infotext.= "<br />";
            $infotext.= "Weitere Informationen finden Sie in unserem Wiki!<br />";
            $infotext.= "Fehlt eine Extension die Sie immer verwenden!? Schreiben Sie uns an info@if-20.com<br />";
            $infotext.= "<br />";
        }
        
        else if($parameters['field']=="extension_t3_less_info") {
            $infotext = "FTM-Templates nutzen die t3_less-Extension um CSS zu generieren.<br />";
            $infotext.= "Dabei werden der Pfad zu den Less-Quelldateien und zu den compilierten CSS-Dateien automatisch aus dem angegebenen fileadmin-Verzeichnis generiert.<br />";
            $infotext.= "<br />";
            $infotext.= "Weitere Informationen zum Less im FTM finden Sie ".$this->wikiLink('CSS-LESS', 'hier').".<br />";
            $infotext.= "<br />";
        }
        
        else if($parameters['field']=="less_variable_info") {
            $infotext = "Hier können Less-Variablen für die FTM-Templates generiert werden.<br />";
            $infotext.= "Folgende Less-Variablen bietet der FTM von Haus aus:<br />";
            $infotext.= "<b>@baseUrl</b> -> bspw. http://www.if-20.com <br />";
            $infotext.= "<b>@baseUrlTemplate</b> -> bspw. http://www.if-20.com/fileadmin/if20/<br />";
            $infotext.= "<b>@fileadminDir</b> -> bspw. if20<br />";
            $infotext.= "<br />";
            $infotext.= "Somit können also auch selbst immer aktuelle Variablen generiert werden, <b>@baseUrlImage</b> könnte dann: <b>@{baseUrlTemplate}img/</b> oder alternativ: <b>@{baseUrl}fileadmin/@{fileadminDir}/template/img</b> lauten.<br />";
            $infotext.= "<br />";
            $infotext.= "Weitere Informationen zum Less im FTM finden Sie ".$this->wikiLink('CSS-LESS', 'hier').".<br />";
            $infotext.= "<br />";
        }
        
        else if($parameters['field']=="marker_info") {
            $infotext = "Hier können Sie beliebig viele Marker für Ihr FTM-Template bereitstellen.<br />";
            $infotext.= "<br />";
            $infotext.= "Alle Informationen zu Markern, deren Verwendung und wie Sie diese Serverübergreifend austauschen können finden Sie ".$this->wikiLink('Fluid-Marker', 'hier').".<br />";
            $infotext.= "<br />";
        }
        
        else if($parameters['field']=="marker_save") {
                
            $script     = "";
            $insertHref = "";
            $insertLink = "";
            
            $markerSelection = "";
            $snippetFolder = t3lib_div::getFileAbsFileName("uploads/tx_ftm/");
            if(@file_exists($snippetFolder.'marker.serialized')) {
                $markerSerialized = file_get_contents($snippetFolder.'marker.serialized');
                $markerArray = unserialize($markerSerialized);
                
                if(is_array($markerArray) && !empty($markerArray)) {
                    
                    $markerSelection = "<span><strong>Aus Vorlage einfügen:</strong></span><br /><select id=\"ftm_insertMarkerSelect_".$uid."\">";
                    
                    foreach($markerArray as $marker) {
                        $markerSelection.= "<option value=\"".$marker['markerName']."\">lib.".$marker['markerName']." (".$marker['markerType'].") ".$marker['markerDescription']."</option>";
                    }
                    $markerSelection.= "</select>";
                    
                    // JavaScript zum Anpassen des Insert-Links
                    $script = '<script type="text/javascript">'.LF;
                    $script.= 'function ftm_generateInsertMarkerLink_'.$uid.'() {'.LF;
                    $script.= '  var tempValue  = document.getElementById("ftm_insertMarkerSelect_'.$uid.'").value;'.LF;
                    $script.= '  var tempHref   = document.getElementById("ftm_insertMarkerLink_'.$uid.'").href;'.LF;
                    $script.= '  var tempAdd    = "&tx_ftm_web_ftmftm[markerName]="+tempValue;'.LF;
                    $script.= '  document.getElementById("ftm_insertMarkerLink_'.$uid.'").href = tempHref+tempAdd;'.LF;
                    $script.= 'return confirm("Marker wirklich aus Vorlage überschreiben?");}'.LF;
                    $script.= '</script>'.LF;
                    
                    
                    // Insert-Link
                    $insertHref = '/typo3/mod.php?M=web_FtmFtm&amp;id='.$pid.'&amp;tx_ftm_web_ftmftm[action]=insertMarker&amp;tx_ftm_web_ftmftm[controller]=TemplateManager&amp;tx_ftm_web_ftmftm[marker]='.$uid; 
                    $insertLink = '<a href="'.$insertHref.'" id="ftm_insertMarkerLink_'.$uid.'" onclick="ftm_generateInsertMarkerLink_'.$uid.'()"><span class="t3-icon t3-icon-actions t3-icon-actions-document t3-icon-document-paste-after">&nbsp;</span></a>';
                    
                }
                else {
                    $markerSelection = "Es sind noch keine gemerkten Marker vorhanden.";
                }
            }
            else {
                $syncHref = '/typo3/mod.php?M=web_FtmFtm&amp;id='.$pid.'&amp;tx_ftm_web_ftmftm[action]=loadSnippets&amp;tx_ftm_web_ftmftm[controller]=TemplateManager'; 
                $markerSelection = "Es sind noch keine gemerkten Marker vorhanden. <a href=\"".$syncHref."\"><span style=\"color: red\">Bitte synchronisieren Sie erst Ihre Marker in der Übersicht.</span></a>";
            }
            
            
            
            
            $markerSaveUri = "/typo3/mod.php?M=web_FtmFtm&id=".$pid."&tx_ftm_web_ftmftm[action]=saveMarker&tx_ftm_web_ftmftm[controller]=TemplateManager&tx_ftm_web_ftmftm[marker]=".$uid."";
            $saveLink = "<a href=\"".$markerSaveUri."\" title=\"Marker in PluginCloud merken\"><img src=\"".$imagePath."marker_save.png\">";
            $infotext = $saveLink." <span>&nbsp;<strong>Hier klicken um den Marker in der PluginCloud zu merken, so dass dieser zu einem späteren Zeitpunkt wiederverwendet werden kann.</strong></span></a><br />";
            $infotext.= "<br /><u>Achtung:</u> Bereits existierende Marker mit dem gleichen Namen werden überschrieben!<br />Beachten Sie bitte auch, das wenn Sie den FTM mit einem public-Key verwenden, alle anderen User die gemerkten Marker sehen können!<br /><br />";
            $infotext.= $script.$markerSelection." ".$insertLink."<br /><br />";
        }
        
        return $infotext;
    }


    protected function wikiLink($link, $label) {
        $wikiLink = "http://if-20.com/hilfe-community/wiki-documentation/fluid-template-manager/wiki/";
        return "<a href=\"".$wikiLink.$link."/\" target=\"_blank\"><u>".$label."</u></a>";
    }

}

?>