<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2012 Thomas Deuling <typo3@coding.ms>, coding.ms
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Managed alle Aktionen rund um TYAML-Datensaetze
 *
 * @package ftm
 * @subpackage Service
 */
class Tx_Ftm_Service_Tyaml {
    

    /**
     * Benoetigte Verzeichnis Struktur
     * @var array
     * @since 1.0.0
     */
    public static $directories = array(
        'uploads/tx_gridelements' => 'Hier liegen die Bilder der Grid-Layouts',
        'uploads/media'           => 'Hier liegen die Bilder der Backend-Layouts'
    );

    /**
     * Benoetigte Backend-Layouts
     * @var array
     * @since 1.0.0
     */
    protected $backendLayouts = array(
        'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout C - Startsite' => array(
            'sorting'     => '128', 
            'title'       => 'C - Startsite', 
            'description' => 'Content (Startsite)', 
            'config'      => 'backend_layout {\r\n colCount = 3\r\n    rowCount = 5\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = TEASER\r\n                   colspan = 3\r\n                 colPos = 3\r\n              }\r\n           }\r\n       }\r\n       2 {\r\n         columns {\r\n               1 {\r\n                 name = CONTENT\r\n                  colspan = 3\r\n                 rowspan = 3\r\n                 colPos = 0\r\n              }\r\n           }\r\n       }\r\n       3 {\r\n         columns {\r\n           }\r\n       }\r\n       4 {\r\n         columns {\r\n           }\r\n       }\r\n       5 {\r\n         columns {\r\n               1 {\r\n                 name = EXTENDED\r\n                 colspan = 3\r\n                 colPos = 4\r\n              }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'icon'        => ''
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout MCS' => array(
            'sorting'     => '256', 
            'title'       => 'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout MCS', 
            'description' => 'Menu - Content - Side', 
            'config'      => 'backend_layout {\r\n colCount = 5\r\n    rowCount = 5\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = TEASER\r\n                   colspan = 5\r\n                 colPos = 3\r\n              }\r\n           }\r\n       }\r\n       2 {\r\n         columns {\r\n               1 {\r\n                 name = MENU\r\n                 rowspan = 3\r\n                 colPos = 1\r\n              }\r\n               2 {\r\n                 name = CONTENT\r\n                  colspan = 3\r\n                 rowspan = 3\r\n                 colPos = 0\r\n              }\r\n               3 {\r\n                 name = SIDE\r\n                 rowspan = 3\r\n                 colPos = 2\r\n              }\r\n           }\r\n       }\r\n       3 {\r\n         columns {\r\n           }\r\n       }\r\n       4 {\r\n         columns {\r\n           }\r\n       }\r\n       5 {\r\n         columns {\r\n               1 {\r\n                 name = EXTENDED\r\n                 colspan = 5\r\n                 colPos = 4\r\n              }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'icon'        => 'FTM_1.0.0_-_TYAML_3.0.0_BackendLayout_MCS.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout SCM' => array(
            'sorting'     => '512', 
            'title'       => 'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout SCM', 
            'description' => 'Side - Content - Menu', 
            'config'      => 'backend_layout {\r\n colCount = 5\r\n    rowCount = 5\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = TEASER\r\n                   colspan = 5\r\n                 colPos = 3\r\n              }\r\n           }\r\n       }\r\n       2 {\r\n         columns {\r\n               1 {\r\n                 name = SIDE\r\n                 rowspan = 3\r\n                 colPos = 2\r\n              }\r\n               2 {\r\n                 name = CONTENT\r\n                  colspan = 3\r\n                 rowspan = 3\r\n                 colPos = 0\r\n              }\r\n               3 {\r\n                 name = MENU\r\n                 rowspan = 3\r\n                 colPos = 1\r\n              }\r\n           }\r\n       }\r\n       3 {\r\n         columns {\r\n           }\r\n       }\r\n       4 {\r\n         columns {\r\n           }\r\n       }\r\n       5 {\r\n         columns {\r\n               1 {\r\n                 name = EXTENDED\r\n                 colspan = 5\r\n                 colPos = 4\r\n              }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'icon'        => 'FTM_1.0.0_-_TYAML_3.0.0_BackendLayout_SCM.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout MSC' => array(
            'sorting'     => '768', 
            'title'       => 'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout MSC', 
            'description' => 'Menu - Side - Content', 
            'config'      => 'backend_layout {\r\n colCount = 5\r\n    rowCount = 5\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = TEASER\r\n                   colspan = 5\r\n                 colPos = 3\r\n              }\r\n           }\r\n       }\r\n       2 {\r\n         columns {\r\n               1 {\r\n                 name = MENU\r\n                 rowspan = 3\r\n                 colPos = 1\r\n              }\r\n               2 {\r\n                 name = SIDE\r\n                 rowspan = 3\r\n                 colPos = 2\r\n              }\r\n               3 {\r\n                 name = CONTENT\r\n                  colspan = 3\r\n                 rowspan = 3\r\n                 colPos = 0\r\n              }\r\n           }\r\n       }\r\n       3 {\r\n         columns {\r\n           }\r\n       }\r\n       4 {\r\n         columns {\r\n           }\r\n       }\r\n       5 {\r\n         columns {\r\n               1 {\r\n                 name = EXTENDED\r\n                 colspan = 5\r\n                 colPos = 4\r\n              }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'icon'        => 'FTM_1.0.0_-_TYAML_3.0.0_BackendLayout_MSC.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout SMC' => array(
            'sorting'     => '1024', 
            'title'       => 'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout SMC', 
            'description' => 'Side - Menu -Content', 
            'config'      => 'backend_layout {\r\n    colCount = 5\r\n    rowCount = 5\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = TEASER\r\n                   colspan = 5\r\n                 colPos = 3\r\n              }\r\n           }\r\n       }\r\n       2 {\r\n         columns {\r\n               1 {\r\n                 name = SIDE\r\n                 rowspan = 3\r\n                 colPos = 2\r\n              }\r\n               2 {\r\n                 name = MENU\r\n                 rowspan = 3\r\n                 colPos = 1\r\n              }\r\n               3 {\r\n                 name = CONTENT\r\n                  colspan = 3\r\n                 rowspan = 3\r\n                 colPos = 0\r\n              }\r\n           }\r\n       }\r\n       3 {\r\n         columns {\r\n           }\r\n       }\r\n       4 {\r\n         columns {\r\n           }\r\n       }\r\n       5 {\r\n         columns {\r\n               1 {\r\n                 name = EXTENDED\r\n                 colspan = 5\r\n                 colPos = 4\r\n              }\r\n           }\r\n       }\r\n   }\r\n}', 
            'icon'        => 'FTM_1.0.0_-_TYAML_3.0.0_BackendLayout_SMC.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout CSM' => array(
            'sorting'     => '1280', 
            'title'       => 'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout CSM', 
            'description' => 'Content - Side - Menu', 
            'config'      => 'backend_layout {\r\n colCount = 5\r\n    rowCount = 5\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = TEASER\r\n                   colspan = 5\r\n                 colPos = 3\r\n              }\r\n           }\r\n       }\r\n       2 {\r\n         columns {\r\n               1 {\r\n                 name = CONTENT\r\n                  colspan = 3\r\n                 rowspan = 3\r\n                 colPos = 0\r\n              }\r\n               2 {\r\n                 name = SIDE\r\n                 rowspan = 3\r\n                 colPos = 2\r\n              }\r\n               3 {\r\n                 name = MENU\r\n                 rowspan = 3\r\n                 colPos = 1\r\n              }\r\n           }\r\n       }\r\n       3 {\r\n         columns {\r\n           }\r\n       }\r\n       4 {\r\n         columns {\r\n           }\r\n       }\r\n       5 {\r\n         columns {\r\n               1 {\r\n                 name = EXTENDED\r\n                 colspan = 5\r\n                 colPos = 4\r\n              }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'icon'        => 'FTM_1.0.0_-_TYAML_3.0.0_BackendLayout_CSM.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout CMS' => array(
            'sorting'     => '1536', 
            'title'       => 'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout CMS', 
            'description' => 'Content - Menu - Side', 
            'config'      => 'backend_layout {\r\n    colCount = 5\r\n    rowCount = 5\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = TEASER\r\n                   colspan = 5\r\n                 colPos = 3\r\n              }\r\n           }\r\n       }\r\n       2 {\r\n         columns {\r\n               1 {\r\n                 name = CONTENT\r\n                  colspan = 3\r\n                 rowspan = 3\r\n                 colPos = 0\r\n              }\r\n               2 {\r\n                 name = MENU\r\n                 rowspan = 3\r\n                 colPos = 1\r\n              }\r\n               3 {\r\n                 name = SIDE\r\n                 rowspan = 3\r\n                 colPos = 2\r\n              }\r\n           }\r\n       }\r\n       3 {\r\n         columns {\r\n           }\r\n       }\r\n       4 {\r\n         columns {\r\n           }\r\n       }\r\n       5 {\r\n         columns {\r\n               1 {\r\n                 name = EXTENDED\r\n                 colspan = 5\r\n                 colPos = 4\r\n              }\r\n           }\r\n       }\r\n   }\r\n}', 
            'icon'        => 'FTM_1.0.0_-_TYAML_3.0.0_BackendLayout_CMS.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout MC' => array(
            'sorting'     => '1792', 
            'title'       => 'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout MC', 
            'description' => 'Menu - Content', 
            'config'      => 'backend_layout {\r\n colCount = 4\r\n    rowCount = 5\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = TEASER\r\n                   colspan = 4\r\n                 colPos = 3\r\n              }\r\n           }\r\n       }\r\n       2 {\r\n         columns {\r\n               1 {\r\n                 name = MENU\r\n                 rowspan = 3\r\n                 colPos = 1\r\n              }\r\n               2 {\r\n                 name = CONTENT\r\n                  colspan = 3\r\n                 rowspan = 3\r\n                 colPos = 0\r\n              }\r\n           }\r\n       }\r\n       3 {\r\n         columns {\r\n           }\r\n       }\r\n       4 {\r\n         columns {\r\n           }\r\n       }\r\n       5 {\r\n         columns {\r\n               1 {\r\n                 name = EXTENDED\r\n                 colspan = 4\r\n                 colPos = 4\r\n              }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'icon'        => 'FTM_1.0.0_-_TYAML_3.0.0_BackendLayout_MC.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout SC' => array(
            'sorting'     => '2048', 
            'title'       => 'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout SC', 
            'description' => 'Side - Content', 
            'config'      => 'backend_layout {\r\n colCount = 4\r\n    rowCount = 5\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = TEASER\r\n                   colspan = 4\r\n                 colPos = 3\r\n              }\r\n           }\r\n       }\r\n       2 {\r\n         columns {\r\n               1 {\r\n                 name = SIDE\r\n                 rowspan = 3\r\n                 colPos = 2\r\n              }\r\n               2 {\r\n                 name = CONTENT\r\n                  colspan = 3\r\n                 rowspan = 3\r\n                 colPos = 0\r\n              }\r\n           }\r\n       }\r\n       3 {\r\n         columns {\r\n           }\r\n       }\r\n       4 {\r\n         columns {\r\n           }\r\n       }\r\n       5 {\r\n         columns {\r\n               1 {\r\n                 name = EXTENDED\r\n                 colspan = 4\r\n                 colPos = 4\r\n              }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'icon'        => 'FTM_1.0.0_-_TYAML_3.0.0_BackendLayout_SC.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout CM' => array(
            'sorting'     => '2304', 
            'title'       => 'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout CM', 
            'description' => 'Content - Menu', 
            'config'      => 'backend_layout {\r\n colCount = 4\r\n    rowCount = 5\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = TEASER\r\n                   colspan = 4\r\n                 colPos = 3\r\n              }\r\n           }\r\n       }\r\n       2 {\r\n         columns {\r\n               1 {\r\n                 name = CONTENT\r\n                  colspan = 3\r\n                 rowspan = 3\r\n                 colPos = 0\r\n              }\r\n               2 {\r\n                 name = MENU\r\n                 rowspan = 3\r\n                 colPos = 1\r\n              }\r\n           }\r\n       }\r\n       3 {\r\n         columns {\r\n           }\r\n       }\r\n       4 {\r\n         columns {\r\n           }\r\n       }\r\n       5 {\r\n         columns {\r\n               1 {\r\n                 name = EXTENDED\r\n                 colspan = 4\r\n                 colPos = 4\r\n              }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'icon'        => 'FTM_1.0.0_-_TYAML_3.0.0_BackendLayout_CM.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout CS' => array(
            'sorting'     => '2560', 
            'title'       => 'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout CS', 
            'description' => 'Content - Side', 
            'config'      => 'backend_layout {\r\n colCount = 4\r\n    rowCount = 5\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = TEASER\r\n                   colspan = 4\r\n                 colPos = 3\r\n              }\r\n           }\r\n       }\r\n       2 {\r\n         columns {\r\n               1 {\r\n                 name = CONTENT\r\n                  colspan = 3\r\n                 rowspan = 3\r\n                 colPos = 0\r\n              }\r\n               2 {\r\n                 name = SIDE\r\n                 rowspan = 3\r\n                 colPos = 2\r\n              }\r\n           }\r\n       }\r\n       3 {\r\n         columns {\r\n           }\r\n       }\r\n       4 {\r\n         columns {\r\n           }\r\n       }\r\n       5 {\r\n         columns {\r\n               1 {\r\n                 name = EXTENDED\r\n                 colspan = 4\r\n                 colPos = 4\r\n              }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'icon'        => 'FTM_1.0.0_-_TYAML_3.0.0_BackendLayout_CS.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout C' => array(
            'sorting'     => '2816', 
            'title'       => 'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout C', 
            'description' => 'Content', 
            'config'      => 'backend_layout {\r\n colCount = 3\r\n    rowCount = 5\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = TEASER\r\n                   colspan = 3\r\n                 colPos = 3\r\n              }\r\n           }\r\n       }\r\n       2 {\r\n         columns {\r\n               1 {\r\n                 name = CONTENT\r\n                  colspan = 3\r\n                 rowspan = 3\r\n                 colPos = 0\r\n              }\r\n           }\r\n       }\r\n       3 {\r\n         columns {\r\n           }\r\n       }\r\n       4 {\r\n         columns {\r\n           }\r\n       }\r\n       5 {\r\n         columns {\r\n               1 {\r\n                 name = EXTENDED\r\n                 colspan = 3\r\n                 colPos = 4\r\n              }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'icon'        => 'FTM_1.0.0_-_TYAML_3.0.0_BackendLayout_C.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - BackendLayout C - Empty' => array(
            'sorting'     => '3072', 
            'title'       => 'C - Empty', 
            'description' => 'Content (with empty layout)', 
            'config'      => 'backend_layout {\r\n   colCount = 1\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = CONTENT\r\n                  colPos = 0\r\n              }\r\n           }\r\n       }\r\n   }\r\n}', 
            'icon'        => ''
        )        
    );

    /**
     * Benoetigte Grid-Layouts
     * @var array
     * @since 1.0.0
     */
    protected $gridLayouts = array(
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 100' => array(
            'sorting'        => '256', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 100', 
            'description'    => 'GridLayout-100', 
            'config'         => 'backend_layout {\r\n   colCount = 1\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = box-content\r\n                  colPos = 10\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_100.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 80-20' => array(
            'sorting'        => '512', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 80-20', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colspan = 4\r\n                 colPos = 11\r\n             }\r\n               2 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_80-20.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 75-25' => array(
            'sorting'        => '640', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 75-25', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 4\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colspan = 3\r\n                 colPos = 11\r\n             }\r\n               2 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_75-25.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 66-33' => array(
            'sorting'        => '768', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 66-33', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 4\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colspan = 3\r\n                 colPos = 11\r\n             }\r\n               2 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_66-33.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 62-38' => array(
            'sorting'        => '1024', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 62-38', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colspan = 3\r\n                 colPos = 11\r\n             }\r\n               2 {\r\n                 name = Rechts\r\n                   colspan = 2\r\n                 colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_62-38.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 60-40' => array(
            'sorting'        => '1280', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 60-40', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colspan = 3\r\n                 colPos = 11\r\n             }\r\n               2 {\r\n                 name = Rechts\r\n                   colspan = 2\r\n                 colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_60-40.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 50-50' => array(
            'sorting'        => '1536', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 50-50', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 2\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_50-50.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 40-60' => array(
            'sorting'        => '1664', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 40-60', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colspan = 2\r\n                 colPos = 11\r\n             }\r\n               2 {\r\n                 name = Rechts\r\n                   colspan = 3\r\n                 colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_40-60.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 38-62' => array(
            'sorting'        => '1792', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 38-62', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colspan = 2\r\n                 colPos = 11\r\n             }\r\n               2 {\r\n                 name = Rechts\r\n                   colspan = 3\r\n                 colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_38-62.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 33-66' => array(
            'sorting'        => '1920', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 33-66', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 3\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Rechts\r\n                   colspan = 2\r\n                 colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_33-66.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 25-75' => array(
            'sorting'        => '2048', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 25-75', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 4\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Rechts\r\n                   colspan = 3\r\n                 colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_25-75.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-80' => array(
            'sorting'        => '2944', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-80', 
            'description'    => 'GridLayout-20-80', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Rechts\r\n                   colspan = 4\r\n                 colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_20-80.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 33-33-33' => array(
            'sorting'        => '5856', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 33-33-33', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 3\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Mitte\r\n                    colPos = 13\r\n             }\r\n               3 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_33-33-33.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 40-40-20' => array(
            'sorting'        => '5120', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 40-40-20', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colspan = 2\r\n                 colPos = 11\r\n             }\r\n               2 {\r\n                 name = Mitte\r\n                    colspan = 2\r\n                 colPos = 13\r\n             }\r\n               3 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_40-40-20.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 40-20-40' => array(
            'sorting'        => '5376', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 40-20-40', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colspan = 2\r\n                 colPos = 11\r\n             }\r\n               2 {\r\n                 name = Mitte\r\n                    colPos = 13\r\n             }\r\n               3 {\r\n                 name = Rechts\r\n                   colspan = 2\r\n                 colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_40-20-40.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-40-40' => array(
            'sorting'        => '6162', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-40-40', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Mitte\r\n                    colspan = 2\r\n                 colPos = 13\r\n             }\r\n               3 {\r\n                 name = Rechts\r\n                   colspan = 2\r\n                 colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_20-40-40.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 60-20-20' => array(
            'sorting'        => '4352', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 60-20-20', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colspan = 3\r\n                 colPos = 11\r\n             }\r\n               2 {\r\n                 name = Mitte\r\n                    colPos = 13\r\n             }\r\n               3 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_60-20-20.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-60-20' => array(
            'sorting'        => '6156', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-60-20', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Mitte\r\n                    colspan = 3\r\n                 colPos = 13\r\n             }\r\n               3 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_20-60-20.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-20-60' => array(
            'sorting'        => '6168', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-20-60', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Mitte\r\n                    colPos = 13\r\n             }\r\n               3 {\r\n                 name = Rechts\r\n                   colspan = 3\r\n                 colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_20-20-60.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 50-25-25' => array(
            'sorting'        => '4864', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 50-25-25', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 4\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colspan = 2\r\n                 colPos = 11\r\n             }\r\n               2 {\r\n                 name = Mitte\r\n                    colPos = 13\r\n             }\r\n               3 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_50-25-25.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 25-50-25' => array(
            'sorting'        => '5904', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 25-50-25', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 4\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Mitte\r\n                    colspan = 2\r\n                 colPos = 13\r\n             }\r\n               3 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_25-50-25.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 25-25-50' => array(
            'sorting'        => '5952', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 25-25-50', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 4\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Mitte\r\n                    colPos = 13\r\n             }\r\n               3 {\r\n                 name = Rechts\r\n                   colspan = 2\r\n                 colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_25-25-50.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 25-25-25-25' => array(
            'sorting'        => '6192', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 25-25-25-25', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 4\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Halblinks\r\n                    colPos = 12\r\n             }\r\n               3 {\r\n                 name = Halbrechts\r\n                   colPos = 14\r\n             }\r\n               4 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_25-25-25-25.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 40-20-20-20' => array(
            'sorting'        => '6180', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 40-20-20-20', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colspan = 2\r\n                 colPos = 11\r\n             }\r\n               2 {\r\n                 name = Halblinks\r\n                    colPos = 12\r\n             }\r\n               3 {\r\n                 name = Halbrechts\r\n                   colPos = 14\r\n             }\r\n               4 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_40-20-20-20.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-40-20-20' => array(
            'sorting'        => '6360', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-40-20-20', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Halblinks\r\n                    colspan = 2\r\n                 colPos = 12\r\n             }\r\n               3 {\r\n                 name = Halbrechts\r\n                   colPos = 14\r\n             }\r\n               4 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_20-40-20-20.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-20-40-20' => array(
            'sorting'        => '6400', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-20-40-20', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Halblinks\r\n                    colPos = 12\r\n             }\r\n               3 {\r\n                 name = Halbrechts\r\n                   colspan = 2\r\n                 colPos = 14\r\n             }\r\n               4 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_20-20-40-20.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-20-20-40' => array(
            'sorting'        => '7424', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-20-20-40', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Halblinks\r\n                    colPos = 12\r\n             }\r\n               3 {\r\n                 name = Halbrechts\r\n                   colPos = 14\r\n             }\r\n               4 {\r\n                 name = Rechts\r\n                   colspan = 2\r\n                 colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_20-20-20-40.jpg'
        ),
        'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-20-20-20-20' => array(
            'sorting'        => '7680', 
            'title'          => 'FTM 1.0.0 - TYAML 3.0.0 - GridLayout 20-20-20-20-20', 
            'description'    => '', 
            'config'         => 'backend_layout {\r\n   colCount = 5\r\n    rowCount = 1\r\n    rows {\r\n      1 {\r\n         columns {\r\n               1 {\r\n                 name = Links\r\n                    colPos = 11\r\n             }\r\n               2 {\r\n                 name = Halblinks\r\n                    colPos = 12\r\n             }\r\n               3 {\r\n                 name = Mitte\r\n                    colPos = 13\r\n             }\r\n               4 {\r\n                 name = Halbrechts\r\n                   colPos = 14\r\n             }\r\n               5 {\r\n                 name = Rechts\r\n                   colPos = 15\r\n             }\r\n           }\r\n       }\r\n   }\r\n}\r\n', 
            'pi_flexform_ds' => 'FILE:typo3conf/ext/ftm/res/template/ext/gridelements/flexFormTyaml.xml', 
            'icon'           => 'FTM_1.0.0_-_TYAML_3.0.0_GridLayout_20-20-20-20-20.jpg'
        )
    );


    /**
     * Grid-Layout Repository
     *
     * @var Tx_Ftm_Domain_Repository_GridLayoutRepository
     */
    protected $gridLayoutRepository;

    /**
     * Backend-Layout Repository
     *
     * @var Tx_Ftm_Domain_Repository_BackendLayoutRepository
     */
    protected $backendLayoutRepository;

    /**
     * Pages Repository
     *
     * @var Tx_Ftm_Domain_Repository_PagesRepository
     */
    protected $pagesRepository;

    /**
     * Persistence-manager
     *
     * @var Tx_Extbase_Persistence_Manager
     */
    protected $persistenceManager;

    /**
     * Object-Manager
     *
     * @var Tx_Extbase_Object_ObjectManager
     */
    protected $objectManager;

    /**
     * Meldungen
     *
     * @var string
     */
    protected $messages = "";

    /**
     * injectGridLayoutRepository
     *
     * @param Tx_Ftm_Domain_Repository_GridLayoutRepository $gridLayoutRepository
     * @return void
     */
    public function injectGridLayoutRepository(Tx_Ftm_Domain_Repository_GridLayoutRepository $gridLayoutRepository) {
        $this->gridLayoutRepository = $gridLayoutRepository;
    }

    /**
     * injectBackendLayoutRepository
     *
     * @param Tx_Ftm_Domain_Repository_BackendLayoutRepository $backendLayoutRepository
     * @return void
     */
    public function injectBackendLayoutRepository(Tx_Ftm_Domain_Repository_BackendLayoutRepository $backendLayoutRepository) {
        $this->backendLayoutRepository = $backendLayoutRepository;
    }

    /**
     * injectPagesRepository
     *
     * @param Tx_Ftm_Domain_Repository_PagesRepository $pagesRepository
     * @return void
     */
    public function injectPagesRepository(Tx_Ftm_Domain_Repository_PagesRepository $pagesRepository) {
        $this->pagesRepository = $pagesRepository;
    }

    /**
     * injectPersistenceManager
     *
     * @param Tx_Extbase_Persistence_Manager $persistenceManager
     * @return void
     */
    public function injectPersistenceManager(Tx_Extbase_Persistence_Manager $persistenceManager) {
        $this->persistenceManager = $persistenceManager;
    }

    /**
     * injectObjectManager
     *
     * @param Tx_Extbase_Object_ObjectManager $objectManager
     * @return void
     */
    public function injectObjectManager(Tx_Extbase_Object_ObjectManager $objectManager) {
        $this->objectManager = $objectManager;
    }
    
    /**
     * Prueft ob das Sys-Template vorhanden ist, und
     * generiert es ggf. neu
     * Dies machen wir ohne Repository, weil wir noch nicht
     * mappen koennen.
     *
     * @author     Thomas Deuling <typo3@coding.ms>
     * @since      22.11.2013
     * 
     * @return mixed boolean wenn alles aktuell ist, ansonsten die Meldungens
     */
    public function checkTyaml($pid) {
        
        
        // Benoetigten Verzeichnisse pruefen
        // $this->checkRequiredDirectories();
        
        
        
        
        
        // Erforderlichen Seiten ermitteln
        $globalStoragePage = $this->pagesRepository->findOneByTitleAndPid("GlobalStorage",  0);
        $gridLayoutPage    = $this->pagesRepository->findOneByTitleAndPid("GridLayouts",    $globalStoragePage->getUid());
        $backendLayoutPage = $this->pagesRepository->findOneByTitleAndPid("BackendLayouts", $globalStoragePage->getUid());
        
        
        //die($gridLayoutPage->getTitle().".".$gridLayoutPage->getUid());
        
        if(!empty($this->gridLayouts)) {
            foreach ($this->gridLayouts as $title => $gridLayout) {
                
                
                // Icon-Verzeichnisse ermitteln und pruefen
                $iconSource = t3lib_div::getFileAbsFileName("EXT:ftm/res/uploads/tx_gridelements/");
                $iconTarget = t3lib_div::getFileAbsFileName("uploads/tx_gridelements/");
                if(!file_exists($iconSource)) {
                    throw new Exception("Media icon source directory '".$iconSource."' not found", 1);
                }
                if(!file_exists($iconTarget)) {
                    throw new Exception("Media icon target directory '".$iconTarget."' not found", 1);
                }
                
                
                // Wenn es das Grid-Layout noch nicht gibt
                // wird es nun erstellt
                $gridLayoutObject = $this->gridLayoutRepository->findOneByTitleAndPid($gridLayout['title'],  $gridLayoutPage->getUid());
                if(!($gridLayoutObject instanceof Tx_Ftm_Domain_Model_GridLayout)) {
                    
                    /**
                     * @var Tx_Ftm_Domain_Model_GridLayout
                     */
                    $gridLayoutObject = $this->objectManager->create('Tx_Ftm_Domain_Model_GridLayout');
                    $gridLayoutObject->setPid($gridLayoutPage->getUid());
                    $gridLayoutObject->setSorting($gridLayout['sorting']);
                    $gridLayoutObject->setTitle($gridLayout['title']);
                    $gridLayoutObject->setDescription($gridLayout['description']);
                    $gridLayoutObject->setConfig(str_replace('\r\n', "\n", $gridLayout['config']));
                    $gridLayoutObject->setPiFlexformDs($gridLayout['pi_flexform_ds']);
                    $gridLayoutObject->setIcon($gridLayout['icon']);
            
                    // Seite speichern
                    $this->gridLayoutRepository->add($gridLayoutObject);
                              
                    // und persistieren
                    $this->persistenceManager->persistAll();
                    
                    // Icon bereitstellen
                    if(file_exists($iconSource.$gridLayout['icon'])) {
                        copy($iconSource.$gridLayout['icon'], $iconTarget.$gridLayout['icon']);
                    }
                    else {
                        throw new Exception("Media icon '".$iconSource.$gridLayout['icon']."' not found", 1);
                    }
                    
                }

            }
        }
        
        /**
         * @ToDo: Nachricht uber erstellte Layouts ausgeben
         */
        
        
        if(!empty($this->backendLayouts)) {
            foreach ($this->backendLayouts as $title => $backendLayout) {
                
                
                // Icon-Verzeichnisse ermitteln und pruefen
                $iconSource = t3lib_div::getFileAbsFileName("EXT:ftm/res/uploads/media/");
                $iconTarget = t3lib_div::getFileAbsFileName("uploads/media/");
                if(!file_exists($iconSource)) {
                    throw new Exception("Media icon source directory '".$iconSource."' not found", 1);
                }
                if(!file_exists($iconTarget)) {
                    throw new Exception("Media icon target directory '".$iconTarget."' not found", 1);
                }
                    
                
                // Wenn es das Backend-Layout noch nicht gibt
                // wird es nun erstellt
                $backendLayoutObject = $this->backendLayoutRepository->findOneByTitleAndPid($backendLayout['title'],  $backendLayoutPage->getUid());
                if(!($backendLayoutObject instanceof Tx_Ftm_Domain_Model_BackendLayout)) {
                
                    /**
                     * @var Tx_Ftm_Domain_Model_GridLayout
                     */
                    $backendLayoutObject = $this->objectManager->create('Tx_Ftm_Domain_Model_BackendLayout');
                    $backendLayoutObject->setPid($backendLayoutPage->getUid());
                    $backendLayoutObject->setSorting($backendLayout['sorting']);
                    $backendLayoutObject->setTitle($backendLayout['title']);
                    $backendLayoutObject->setDescription($backendLayout['description']);
                    $backendLayoutObject->setConfig(str_replace('\r\n', "\n", $backendLayout['config']));
                    $backendLayoutObject->setIcon($backendLayout['icon']);
                    
                    // Seite speichern
                    $this->backendLayoutRepository->add($backendLayoutObject);
                              
                    // und persistieren
                    $this->persistenceManager->persistAll();
                    
                    // Icon bereitstellen
                    if(file_exists($iconSource.$backendLayout['icon'])) {
                        copy($iconSource.$backendLayout['icon'], $iconTarget.$backendLayout['icon']);
                    }
                    else {
                        throw new Exception("Media icon '".$iconSource.$backendLayout['icon']."' not found", 1);
                    }
                }
                
            }
        }
        
        
    }
        
       
    
}

?>
