<?php
/**
 * Shows one Less-Variable row
 *
 * @package    TYPO3
 * @subpackage ftm
 * @author     Thomas Deuling <typo3@coding.ms>
 * @since      1.0.0
 */
class Tx_Ftm_ViewHelper_LessVariableStaticRowViewHelper extends Tx_Fluid_Core_ViewHelper_AbstractViewHelper {

    /**
     * Less-Variable Row
     *
     * @param  Tx_Ftm_Domain_Model_Template $fluidTemplate
     * @param  string $lessVariableStatic
     * @author Thomas Deuling <typo3@coding.ms>
     * @return HTML
     * @since  1.0.0
     */
    public function render(Tx_Ftm_Domain_Model_Template $fluidTemplate, $lessVariableName='') {
            
        $tableCells = array();
        $returnHtml = "";
                
                
        // Dateiname und Pfad
        $imagePath    = "/typo3conf/ext/ftm/Resources/Public/Icons/";
        
        
        // TS-Icon
        $tableCells[] = "<a><img src=\"/typo3conf/ext/ftm/Resources/Public/Icons/lessVariable.png\"></a>";

        
       
        if($lessVariableName=='baseUrl') {

            // Less-Variable Type
            $tableCells[] = "string";
            
            // Less-Variable Name
            $tableCells[] = "<a title=\"@".$lessVariableName."\">@".$lessVariableName."</a>";            

            // Less-Variablen Wert
            $tableCells[] = $fluidTemplate->getConfig()->getBaseURL();
        
            // Less-Variable Title/Info
            $tableCells[] = "Base-URL als String (automatisch generiert)";
            
        }
        else if($lessVariableName=='baseUrlTemplate') {
            
            // Less-Variable Type
            $tableCells[] = "string";
            
            // Less-Variable Name
            $tableCells[] = "<a title=\"@".$lessVariableName."\">@".$lessVariableName."</a>";   
            
            // Less-Variablen Wert
            $tableCells[] = $fluidTemplate->getConfig()->getBaseUrl()."fileadmin/".$fluidTemplate->getFileadminDir()."/template/";
        
            // Less-Variable Title/Info
            $tableCells[] = "Pfad zum den Template-Dateien (automatisch generiert)";
            
        }
        else if($lessVariableName=='fileadminDir') {
            
            // Less-Variable Type
            $tableCells[] = "string";
            
            // Less-Variable Name
            $tableCells[] = "<a title=\"@".$lessVariableName."\">@".$lessVariableName."</a>";   
            
            // Less-Variablen Wert
            $tableCells[] = $fluidTemplate->getFileadminDir();
        
            // Less-Variable Title/Info
            $tableCells[] = "Verzeichnis-Name im fileadmin-Verzeichnis (automatisch generiert)";
            
        }
        
       
        
        
        
        // Refresh-Link erstellen
        $uriBuilder = $this->controllerContext->getUriBuilder();
        $lessRefreshUri = $uriBuilder->reset()
                      ->setCreateAbsoluteUri(true)
                      ->uriFor("generateLessVariable", array(), "TemplateManager");
        
        
        // Link im neuen Fenster oeffnen
        $actions = array();
        // $actions[] = "<a href=\"#\" onclick=\"window.location.href='alt_doc.php?returnUrl='+T3_THIS_LOCATION+'&amp;edit[tx_ftm_domain_model_templatelessvariable][".$lessVariable->getUid()."]=edit'; return false;\" title=\"Template bearbeiten\"><img src=\"".$imagePath."lessVariable_edit.png\"></a>";
        // $actions[] = "<a href=\"/".$relPath."\"        title=\"Fluid-".ucfirst($templateType)." (".$filename.") herunterladen\" target=\"_blank\" ><img src=\"".$imagePath."fluid_download.png\"></a>";
        //  $actions[] = "<a href=\"".$lessRefreshUri."\" title=\"Less-Variablen re/generieren\"><img src=\"".$imagePath."lessVariable_refresh.png\"></a>";
        // $actions[] = "<a href=\"/".$relPath."\"        title=\"Fluid-".ucfirst($templateType)." (".$filename.") Informationen\" target=\"_blank\"><img src=\"".$imagePath."fluid_information.png\"></a>";
        
        // Actions
        $tableCells[] = implode("&nbsp;", $actions);
        
        return '<td>'.implode('</td><td>', $tableCells).'</td>';
    }

}
?>