<?php
/**
 * Shows one Marker row
 *
 * @package    TYPO3
 * @subpackage ftm
 * @author     Thomas Deuling <typo3@coding.ms>
 * @since      1.0.0
 */
class Tx_Ftm_ViewHelper_MarkerRowViewHelper extends Tx_Fluid_Core_ViewHelper_AbstractViewHelper {

    /**
     * Marker Row
     *
     * @param  Tx_Ftm_Domain_Model_Template $fluidTemplate
     * @param  Tx_Ftm_Domain_Model_TemplateMarker $marker
     * @author Thomas Deuling <typo3@coding.ms>
     * @return HTML
     * @since  1.0.0
     */
    public function render(Tx_Ftm_Domain_Model_Template $fluidTemplate, Tx_Ftm_Domain_Model_TemplateMarker $marker) {
            
        $tableCells = array();
        $returnHtml = "";
                
                
        // Marker-Daten
        $markerType = $marker->getMarkerType();
        $markerName = $marker->getMarkerName();
        $markerDesc = $marker->getMarkerDescription();
        $imagePath  = "/typo3conf/ext/ftm/Resources/Public/Icons/";
        
        
        // TS-Icon
        $tableCells[] = "<a><img src=\"/typo3conf/ext/ftm/Resources/Public/Icons/marker.png\"></a>";

        
        // Marker-Name
        $tableCells[] = "lib.".$markerName;
        
        
        // Marker-Typ
        $tableCells[] = $markerType;
        
        
        // Marker-Description
        $tableCells[] = $markerDesc;
   
      
        // Link im neuen Fenster oeffnen
        $actions = array();
        
        $title = 'Marker bearbeiten';
        $icon  = 'actions-document-open';
        $actions[] = "<a href=\"#\" onclick=\"window.location.href='alt_doc.php?returnUrl='+T3_THIS_LOCATION+'&amp;edit[tx_ftm_domain_model_templatemarker][".$marker->getUid()."]=edit'; return false;\">".t3lib_iconWorks::getSpriteIcon($icon, array('title' => $title))."</a>";
        
        // Actions
        $tableCells[] = implode("&nbsp;", $actions);
        
   
        
        
        return '<td>'.implode('</td><td>', $tableCells).'</td>';
    }

}
?>